package javax.swing.text;

import java.util.Enumeration;
import java.util.Hashtable;
import javax.swing.Action;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

public abstract class TextAction extends AbstractAction
{
    public TextAction(String name) {
        super(name);
    }
    
    protected final JTextComponent getTextComponent(ActionEvent actionEvent) {
        if (actionEvent != null) {
            Object source = actionEvent.getSource();
            if ((source instanceof JTextComponent)) {
                return (JTextComponent)source;
            }
        }
        return this.getFocusedComponent();
    }
    
    public static final Action[] augmentList(Action[] array, Action[] array2) {
        Hashtable<Object, Action> hashtable = new Hashtable();
        for (Action value : array) {
            String s = (String)value.getValue("Name");
            hashtable.put((s != null) ? s : "", value);
        }
        for (Action value2 : array2) {
            String s2 = (String)value2.getValue("Name");
            hashtable.put((s2 != null) ? s2 : "", value2);
        }
        Action[] array3 = new Action[hashtable.size()];
        int n = 0;
        Enumeration<Object> elements = hashtable.elements();
        while (elements.hasMoreElements()) {
            array3[n++] = (Action)elements.nextElement();
        }
        return array3;
    }
    
    protected final JTextComponent getFocusedComponent() {
        return JTextComponent.getFocusedComponent();
    }
}
